/*
 *  IonCfg - Lightweight multiuse configuration system
 *  Copyright (C) 2011-2014  Alicia Cathryn Coder
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>

struct configvalue
{
  const char* name;
  const char* value;
};

struct configgrouptype
{
  const char* type;
  struct configgroup* groups;
  unsigned int groupcount;
  unsigned int grouplen; // Keeping track of this one within the readconfig function would just be too messy to be worth the later saving on RAM
};

struct configgroup
{
  const char* name;
  struct configvalue* values;
  unsigned int valuecount;
  struct configgrouptype* grouptypes;
  unsigned int grouptypecount;
};

extern const char* cvalue(struct configgroup* cfg, const char* property);
extern struct configgroup* cgroup(struct configgroup* cfg, const char* type, const char* name);
extern struct configgroup* cgrouplist(struct configgroup* cfg, const char* type, unsigned int* count);
extern void readconfig(FILE* file, struct configgroup* group);
extern struct configgroup* loadconfig(const char* filename);
extern void freecgroup(struct configgroup* cfg);
extern void freeconfig(struct configgroup* cfg);
